#!/bin/sh

msg() {
  if [ $1 -ne 0 ]; then
    printf "[ERROR]\n"
    imgs=$(losetup -l | grep ".img" | awk '{print $1}')
    for dev in $imgs; do
      losetup -d $dev;
    done
    exit $1
  else
    printf "[OK]\n"
  fi
}

printf "find losetup    "; [ -x "$(which losetup)" ]; msg $?
printf "find dd         "; [ -x "$(which dd)" ]; msg $?
printf "find sdcard.img "; [ -f sdcard.img ]; msg $?
printf "find debian img "; [ -f "$1" ]; msg $?

imgs=$(losetup -l | grep ".img" | awk '{print $1}')
for dev in $imgs; do
  printf "found attached image $dev, try to detach "; losetup -d $dev; msg $?
done

printf "find loop skdev           "; skdev=$(losetup -f); [ -b "$skdev" ]; msg $?
printf "create loop device skdev  "; losetup -P $skdev sdcard.img; msg $?
printf "find loop dbndev          "; dbndev=$(losetup -f); [ -b "$dbndev" ]; msg $?
printf "create loop device dbndev "; losetup -P $dbndev $1; msg $?

sleep 2

printf "find skdev root partition "; [ -b "${skdev}p2" ]; msg $?
printf "umount skdev root partition "; umount "${skdev}p2"
printf "find dbn root partition   "; [ -b "${dbndev}p1" ]; msg $?
printf "umount debian root partition "; umount "${dbndev}p1"

printf "copy partition %sp1 to %sp2 " $dbndev $skdev
dd if=${dbndev}p1 of=${skdev}p2 bs=1M && sync
msg $?

printf "detach skdev    "; losetup -d $skdev; msg $?
printf "detach dbndev   "; losetup -d $dbndev; msg $?
